/**************************************************************************
* iptrk - ip tracker
* by Jason Nunn <jsno@arafura.net.au>, Darwin, NT, Australia. Aug 2002
* For Arafura Connect
*
* Arafura Connect
* 71 McMinn St
* Darwin NT 0810
* Australia
*
* http://www.arafuraconnect.com.au
* http://jsno.arafuraconnect.com.au
*
* iptrk is a commercial product. usage is unauthorised without written
* aggreement.
*
* =======================================================================
*
**************************************************************************/
#include <curses.h>
#include "defs.h"

PRIVATE WINDOW *win;
PRIVATE int    posy,
               posx,
               lim;
PRIVATE char   *strp;

/**************************************************************************
*
**************************************************************************/
PUBLIC void getstr_rt_init(WINDOW *w, int y, int x, int l, char *s)
{
  win = w;
  posy = y;
  posx = x;
  lim = l;
  strp = s;
  strp[0] = 0;
}

/**************************************************************************
*
**************************************************************************/
PUBLIC int getstr_rt(void)
{
  int ch, l;

  ch = wgetch(win);
  if(ch == ERR)
    return 0;

  l = strlen(strp);

  if(ch < ' ' || ch > 'z') /*special characters*/
  {
    if(ch == KEY_CR)
      return 1;

    if(ch == KEY_DC || ch == KEY_BSPACE)
      if(l > 0)
      {
        strp[l - 1] = 0;
        mvhline(posy, posx, ' ', l);
        waddstr(win, strp);
      }

    return 0;
  }

  if(l >= lim)
  {
    beep();
    return 0;
  }

  strp[l] = ch;
  strp[l + 1] = 0;
  move(posy, posx);
  waddstr(win, strp);
  return 0;
}
