/**************************************************************************
* iptrk - ip tracker
* by Jason Nunn <jsno@arafura.net.au>, Darwin, NT, Australia. Sep 2001
* For Arafura Connect
*
* Arafura Connect
* 71 McMinn St
* Darwin NT 0810
* Australia
*
* http://www.arafuraconnect.com.au
* http://jsno.arafuraconnect.com.au
*
* iptrk is a commercial product. usage is unauthorised without written
* aggreement.
*
* =======================================================================
* report generator (iptrkq_log_ip) log section
*
**************************************************************************/
#include "defs.h"
#include "lib_cgi.p"

#define CGI_WRAPPER_PATH "/cgi-bin/iptrkq_log_ip_cgi.pl"

/**************************************************************************
*
**************************************************************************/
PRIVATE int dir_tab_compar(const void *a, const void *b)
{
  struct in_addr in_a, in_b;

  inet_aton(((dir_entry_t *)a)->name + 4, &in_a);
  inet_aton(((dir_entry_t *)b)->name + 4, &in_b);
  return ntohl(in_a.s_addr) - ntohl(in_b.s_addr);
}

/**************************************************************************
*
**************************************************************************/
int main(void)
{
  int  i;
  char filepath[STR_LEN + 1],
       *qstring;

  qstring = getenv("QUERY_STRING");
  if(qstring == NULL)
  {
    printf(
      "<html><p>E %s()::getenv(QUERY_STRING)<hr></html>", __func__);
    exit(-1);
  }

  sprintf(filepath, "%s/%s", IPTRK_LOG_IP_PATH, qstring);
  get_dir_entries_unsorted(filepath);
  qsort(dir_tab, dir_len, sizeof(dir_entry_t), dir_tab_compar);

  printf(
    "Content-type: text/html\n\n"
    "<html><title>Generate Reports (watch)</title>"
    "<body TEXT=\"#ffffff\" BGCOLOR=\"#000000\" LINK=\"#8888FF\" VLINK=\"#FF0000\">"
    "<font color=\"#d0d0f0\">"
    "<center><img src=\"/iptrk.png\"><p>"
    "<font color=\"#80f0a0\">"
    "log_ip Daily Volume Reports- log selection"
    "<hr><b>");

  for(i = 0; i < dir_len; i++)
  {
    printf(
      "<br><a href=\"" CGI_WRAPPER_PATH "?log=%s/%s\">%s</a>",
      filepath, dir_tab[i].name, dir_tab[i].name);
  }

  printf("</b><p><hr></html>");
  return 0;
}
