/**************************************************************************
* iptrk - ip tracker
* by Jason Nunn <jsno@arafura.net.au>, Darwin, NT, Australia. Dec 2000
* For Arafura Connect
*
* Arafura Connect
* 71 McMinn St
* Darwin NT 0810
* Australia
*
* http://www.arafuraconnect.com.au
* http://jsno.arafuraconnect.com.au
*
* iptrk is a commercial product. usage is unauthorised without written
* aggreement.
*
* =======================================================================
* logging code
*
**************************************************************************/
#include "defs.h"
#include "lib.p"

/**************************************************************************
* log atoms
*
* E: = error
* W: = Warning
* I: = Information
**************************************************************************/
PUBLIC void print_log_sub(char *buf, char *entry)
{
  char str[STR_LEN + 1];

  str_date(timer, str);
  sprintf(buf, "%08lx %s %s\n", timer, str, entry);
}

PUBLIC void log_m_file(char type, const char *func, char *msg)
{
  FILE *fp;
  char str[STR_LEN + 1],
       str2[STR_LEN + 1];

  if((fp = fopen(IPTRK_LOG, "a")) != NULL)
  {
    if(func == NULL)
      sprintf(str, "%c%s", type, msg);
    else
      sprintf(str, "%c %s()%s", type, func, msg);

    print_log_sub(str2, str);
    fputs(str2, fp);
    fclose(fp);
  }
}

PUBLIC void log_m_text_only(char type, const char *func, char *msg)
{
  if(func == NULL)
    printf("%c%s\n", type, msg);
  else
    printf("%c %s()%s\n", type, func, msg);
}

PUBLIC void log_m_text_file(char type, const char *func, char *msg)
{
  log_m_file(type, func, msg);
  log_m_text_only(type, func, msg);
}

/**************************************************************************
*
**************************************************************************/
PUBLIC void (*log_m)(char, const char *, char *) = log_m_text_only;

PUBLIC void log_e(const char *func, char *msg)
{
  char str[STR_LEN];

  sprintf(str, "%s- %s", msg, strerror(errno));
  log_m('E', func, str);
}
